

// include the library code:
#include <LiquidCrystal.h>
#include <SPI.h>    ^
#include <SD.h>
#include <Wire.h>
#include <Time.h>
#include <DS1307RTC.h>

const int chipSelect = 10;

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(2,3,4,5,6,7);


int count;
int Mikro;
int PAEC_Rn;
int PAEC_Tn;

unsigned long times;
int sensorValue = analogRead(A2);

int mittel;
int WertAlt;
long lastMillis=0;
float  KF;
int T;
long Millisec;
String dataString0 = "";
bool SDCardInitialisiert = false;


// **********************************************************
void setup() {
  // initialize serial communication at 9600 bits per second:
  // additional serial output is useful for for program testing 
  Serial.begin(9600);
  Serial.println("");
 // initialize digital pins for output:
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);  
  //    set up the LCD's number of columns and rows:
   lcd.begin(16, 2);
  // Print a message to the LCD.
   lcd.print("PAEC-Messung");
   lastMillis=millis();
   Serial.print("Initializing SD card...");

  // see if the card is present and can be initialized:
  SDCardInitialisiert = SD.begin(chipSelect);
  if (!SDCardInitialisiert) {
    Serial.println("Card failed, or not present");
    lcd.setCursor(0, 0);
     lcd.print("Fehler SD-card");
    // don't do anything more:
    return;
   
  }
  Serial.println("card initialized.");

  //Filename
   tmElements_t tm;
   RTC.read(tm);
   dataString0 =String(tm.Day);
   dataString0 +=String(tm.Month);
   dataString0 +=String(tm.Year-30);
   dataString0 +=String(tm.Hour);
   dataString0 +=".txt";

   Serial.println(dataString0);
         
   //create a file and header of the table
   
   File dataFile = SD.open(dataString0, FILE_WRITE);
   if (dataFile) {
     dataFile.println("Zeit;  Imp. Rn;   PAEC_Rn;" );
     dataFile.println("    ;         ;     Bq/m3  ; " );
     dataFile.close();
    }

    digitalWrite(9, HIGH);
    digitalWrite(8, HIGH);

    //KF=aBq/h/T/Q  aBq=13.2; T=3600 s /Q =0.25 l/min h = 0.065
    KF=0.226;
   
}

// ****** end of setup  *********



// the loop routine runs over and over again forever:

void loop() {
 
  
  String dataString1 = "";
  String dataString2 = "";
  String dataString3 = "";
  //reading the analog pin of pulse input 
  sensorValue = analogRead(A2); 

   //discrimation of puklses <= 200 digits ( 1 V)
  if (sensorValue>200){
    
    //prevention of muliple counting of pulses of 300 micro seconds 
    if ((sensorValue-WertAlt)>200){
       count=count+1; 
      }
    }

  WertAlt=sensorValue; 
   

//display of lapsed time during the actual counting time and counted pulses
 if ((millis()-lastMillis)%10000==0){
   lcd.setCursor(0, 1);
   lcd.print("                ");
   dataString2 =String((millis()-lastMillis)/1000);
   dataString2 +=" s ";
   dataString2 +=String(count);
   dataString2 +=" Imp";

   lcd.setCursor(0, 1);
   lcd.print(dataString2);
 }
  
 // stop criterion for counting time = 1 hour
 if ((millis()-lastMillis)>3600000){
    lastMillis = millis();  
    //reading  RTC
    tmElements_t tm;
    RTC.read(tm);
   
    PAEC_Rn=count*KF;
        
    //datastring1 for LCD display
    dataString1 =String(millis()/3600000);
    dataString1 +=" : ";
    dataString1 +=String(PAEC_Rn);
    dataString1 +=" Bq/m3";
    
    //datastring3 for SD card storage
    dataString3 =String(tm.Day);
    dataString3 +=" : ";
    dataString3 +=String(tm.Month);
    dataString3 +=" : ";
    dataString3 +=String(tmYearToCalendar(tm.Year));
    dataString3 +="    ";
    dataString3 +=String(tm.Hour);
    dataString3 +=" : ";
    dataString3 +=String(tm.Minute);
    dataString3 +=";   ";

    dataString3 +=String(count);
    dataString3 +=" ; ";
    dataString3 +=String(PAEC_Rn);
    dataString3 +=" ; "; 
    
    lcd.setCursor(0, 0);
    lcd.print("                ");
    lcd.setCursor(0, 0);
    lcd.print(dataString1);
    lcd.setCursor(0, 1);
    lcd.print(dataString2);
    Serial.println(dataString3);
   
    count=0;
   

if(SDCardInitialisiert){
  // open the file. note that only one file can be open at a time,
  // so you have to close this one before opening another.
  File dataFile = SD.open(dataString0, FILE_WRITE);

  // if the file is available, write to it:
  if (dataFile) {
    dataFile.println(dataString3);
    dataFile.close();
    }
 // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening datalog.txt");
  }
}
 }
  delayMicroseconds(1);  // delay in between reads for stability

  
 }

